-- YGREC8/VHDL/ALU8/Wrap_ALU8.vhdl
-- version  jeu. janv.  2 03:51:09 CET 2020
--
-- Released under the GNU AGPLv3 license

Library ieee;
    use ieee.std_logic_1164.all;
Library work;
    use work.all;

entity VG_Wrapper is
  generic (
    -- overridden by the VG code so it doesn't matter that much
    VectGenWidthIn : integer := 24;
    VectGenWidthOut: integer := 18
  );
  port(
    VectIn : in    std_logic_vector(VectGenWidthIn -1 downto 0);
    VectOut: inout std_logic_vector(VectGenWidthOut-1 downto 0);
    VectClk: in std_logic
  );
end VG_Wrapper;

architecture Wrap_ROP2 of VG_Wrapper is
begin

  dut: entity ALU8 port map (
    -- here we "wire" the unit to the Vector Generator ports:
          SRI => VectIn ( 7 downto 0),
          SND => VectIn (15 downto 8),
          NEG => VectIn(16),
      PASS_en => VectIn(17),
       AND_en => VectIn(18),
       XOR_en => VectIn(19),
     OrXor_en => VectIn(20),
          Cin => VectIn(21),
         CMPS => VectIn(22),
     ROP => VectOut( 7 downto 0),
     SUM => VectOut(15 downto 8),
    Cout => VectOut(16));

  -- the wires that enable size autodetection
  VectOut(17) <= '1';
  VectOut(VectGenWidthOut-1) <= VectIn(23);
end Wrap_ROP2;
