-- YGREC8/VHDL/TAP/MUX64/MUX16_C.vhdl
-- created mar. juil. 21 21:07:06 CEST 2020 by whygee@f-cpu.org
-- version mar. juil. 21 23:01:34 CEST 2020 : classic
-- version mar. juil. 21 23:25:19 CEST 2020 : gates
-- version mer. juil. 22 00:04:51 CEST 2020 : gates reduced to 16 bits
-- version mer. juil. 22 15:06:03 CEST 2020 : MUX16 balanced control, version B
-- version mer. juil. 22 15:21:27 CEST 2020 : another BBT-BC, version C
-- version sam. août  1 23:00:46 CEST 2020 : reversed the input bits to ease "MSB-first" shifting
-- version 20200806 : synthesis with Synplify
--
-- Released under the GNU AGPLv3 license
--
-- BBT-BC MUX16 {1,4,5,5} mapped to gates.
-- see BBT_MUX16C.svg
--
-- SYNTHESIS OK

Library ieee;
    use ieee.std_logic_1164.all;
Library SLV;
    use SLV.SLV_utils.all;
Library proasic3;
    use proasic3.all;

entity MUX16 is
  port(
    leaves : in SLV16;
    CTRL : in SLV4;
    root : out SL);
end MUX16;

architecture gates of MUX16 is
  signal L4 : SLV8;
  signal L3 : SLV4;
  signal L2 : SLV2;

  component mx2 port(A, B, S : in std_logic; Y : out std_logic); end component;

begin
  l1a: MX2 port map(A=>L2(0), B=>L2(1), S=>CTRL(0), Y=>root);

  l2a: MX2 port map(A=>L3(0), B=>L3(1), S=>CTRL(1), Y=>L2(0));
  l2b: MX2 port map(A=>L3(2), B=>L3(3), S=>CTRL(3), Y=>L2(1));

  l3a: MX2 port map(A=>L4(0), B=>L4(1), S=>CTRL(2), Y=>L3(0));
  l3b: MX2 port map(A=>L4(2), B=>L4(3), S=>CTRL(2), Y=>L3(1));
  l3c: MX2 port map(A=>L4(4), B=>L4(5), S=>CTRL(2), Y=>L3(2));
  l3d: MX2 port map(A=>L4(6), B=>L4(7), S=>CTRL(2), Y=>L3(3));

  l4a: MX2 port map(B=>leaves(14), A=>leaves(15), S=>CTRL(3), Y=>L4(0));
  l4b: MX2 port map(B=>leaves(12), A=>leaves(13), S=>CTRL(3), Y=>L4(1));
  l4c: MX2 port map(B=>leaves(10), A=>leaves(11), S=>CTRL(3), Y=>L4(2));
  l4d: MX2 port map(B=>leaves( 8), A=>leaves( 9), S=>CTRL(3), Y=>L4(3));
  l4e: MX2 port map(B=>leaves( 6), A=>leaves( 7), S=>CTRL(1), Y=>L4(4));
  l4f: MX2 port map(B=>leaves( 4), A=>leaves( 5), S=>CTRL(1), Y=>L4(5));
  l4g: MX2 port map(B=>leaves( 2), A=>leaves( 3), S=>CTRL(1), Y=>L4(6));
  l4h: MX2 port map(B=>leaves( 0), A=>leaves( 1), S=>CTRL(1), Y=>L4(7));
end gates;
