-- YGREC8/VHDL/TAP/MUX64/MUX64_BBTclassic.vhdl
-- created mar. juil. 21 21:07:06 CEST 2020 by whygee@f-cpu.org
-- version mar. juil. 21 23:01:34 CEST 2020 : classic
-- version mar. juil. 21 23:25:19 CEST 2020 : gates
--
-- Released under the GNU AGPLv3 license
--
-- Another trivial MUX64 but more detailed than the behavioural.
-- Each level of the selection tree is simulated.

Library ieee;
    use ieee.std_logic_1164.all;
Library SLV;
    use SLV.SLV_utils.all;
Library proasic3;
    use proasic3.all;

entity MUX64 is
  port(
    leaves : in SLV64;
    CTRL : in SLV6;
    root : out SL);
end MUX64;

architecture gates of MUX64 is
  signal L6 : SLV32;
  signal L5 : SLV16;
  signal L4 : SLV8;
  signal L3 : SLV4;
  signal L2 : SLV2;
begin
                                     l1x: entity MX2  port map(A=>L2(0),     B=>L2(1)          ,     S=>CTRL(0), Y=>root);
  l2g: for i in L2'range generate    l2x: entity MX2  port map(A=>L3(i),     B=>L3(i+L2'length),     S=>CTRL(1), Y=>L2(i));  end generate l2g;
  l3g: for i in L3'range generate    l3x: entity MX2  port map(A=>L4(i),     B=>L4(i+L3'length),     S=>CTRL(2), Y=>L3(i));  end generate l3g;
  l4g: for i in L4'range generate    l4x: entity MX2  port map(A=>L5(i),     B=>L5(i+L4'length),     S=>CTRL(3), Y=>L4(i));  end generate l4g;
  l5g: for i in L5'range generate    l5x: entity MX2  port map(A=>L6(i),     B=>L6(i+L5'length),     S=>CTRL(4), Y=>L5(i));  end generate l5g;
  l6g: for i in L6'range generate    l6x: entity MX2  port map(A=>leaves(i), B=>leaves(i+L6'length), S=>CTRL(5), Y=>L6(i));  end generate l6g;
end gates;
