-- YGREC8/VHDL/TAP/MUX64/Wrap_MUX64.vhdl
-- created mer. juil. 22 01:21:07 CEST 2020
-- 
-- Released under the GNU AGPLv3 license

Library ieee;
    use ieee.std_logic_1164.all;
Library work;
    use work.all;

entity VG_Wrapper is
  generic (
    -- overridden by the VG code so it doesn't matter that much
    VectGenWidthIn : integer := 71;
    VectGenWidthOut: integer := 3
  );
  port(
    VectIn : in  std_logic_vector(VectGenWidthIn -1 downto 0);
    VectOut: out std_logic_vector(VectGenWidthOut-1 downto 0);
    VectClk: in std_logic
  );
end VG_Wrapper;

architecture Wrap_MUX64 of VG_Wrapper is
begin

  dut: entity MUX64 port map (
     -- here we "wire" the unit to the Vector Generator ports:
    leaves => VectIn(63 downto 0),
      CTRL => VectIn(69 downto 64),
      root => VectOut(0));

  -- the wires that enable size autodetection
  VectOut(1) <= '1';
  VectOut(VectGenWidthOut-1) <= VectIn(70);
end Wrap_MUX64;
