#!/bin/bash
# YGREC8/test_units.sh
# created lun. nov. 13 01:55:52 CET 2017 by Yann Guidon (whygee@f-cpu.org)
# version ven. nov. 17 01:11:13 CET 2017
# version lun. déc. 30 04:22:19 CET 2019
# version dim. mars 29 07:52:30 CEST 2020 clean break on first error
#
# Released under the GNU AGPLv3 license

if ghdl -v |grep "mcode" ; then
  echo "This script does not support mcode, use GHDL with GCC or LLVM backend."
else

  echo
  echo  'This script will run exhaustive self-tests and will take "a while".'
  echo  'Like, around one minute, depending on your CPU and software.'
  echo  'You may interrupt it (CTRL+C) if needed. Please report errors.'
  echo

  msg="test_units.sh finished : OK !"
  for DIR in proasic3v3 Y8 generics ASM FSM INC8 TAP/MUX64
     # TAP/Gray TAP/Counter TAP/Selector TAP/Slice TAP R7 ALU8 INC16 SHL8 CORE
  do
    echo -n '--> going to ' ; pushd $DIR
    ./test.sh || { msg="test_units.sh interrupted by fault"; break; }
    echo -n '<-- back from ' ; popd
  done
  echo $msg
fi
